var Memory, arrMutators, compound, merge, method, normalizeArgs, specHelper, xtraArrMutConf, _ref;
var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
merge = require('../util').merge;
specHelper = require('../specHelper');
arrMutators = require('../mutators/array');
Memory = module.exports = function() {
  this._data = {};
  this.ver = 0;
};
Memory.prototype = {
  get: function(path, obj) {
    if (obj == null) {
      obj = this._data;
    }
    if (path) {
      return this.lookup(path, false, {
        obj: obj
      }).obj;
    } else {
      return obj;
    }
  },
  set: function(path, value, ver, options) {
    var obj, out, parent, prop, refObjCopy, _ref;
    if (options == null) {
      options = {};
    }
    if (value && value.$r) {
      refObjCopy = merge({}, value);
      value = refObjCopy;
    }
    this.ver = ver;
    _ref = out = this.lookup(path, true, options), parent = _ref.parent, prop = _ref.prop;
    obj = out.obj = parent[prop] = value;
    if (options.returnMeta) {
      return out;
    } else {
      return obj;
    }
  },
  del: function(path, ver, options) {
    var curr, key, obj, out, parent, parentProto, prop, value, _ref;
    if (options == null) {
      options = {};
    }
    this.ver = ver;
    _ref = out = this.lookup(path, false, options), parent = _ref.parent, prop = _ref.prop, obj = _ref.obj, path = _ref.path;
    if (!parent) {
      if (options.returnMeta) {
        return out;
      } else {
        return obj;
      }
    }
    if (options.proto) {
      parentProto = Object.getPrototypeOf(parent);
      if (prop in parentProto) {
        curr = {};
        for (key in parentProto) {
          value = parentProto[key];
          if (key !== prop) {
            curr[key] = typeof value === 'object' ? specHelper.create(value) : value;
          }
        }
        parent.__proto__ = curr;
      }
    }
    delete parent[prop];
    if (options.returnMeta) {
      return out;
    } else {
      return obj;
    }
  },
  lookup: function(path, addPath, options) {
    var arrIndex, array, dereffedPath, i, key, keyVal, len, next, origPath, parent, pathSegment, prop, props, proto, rObj, rPath, rRemainingProps, ref, _ref;
    origPath = path;
    proto = options.proto, array = options.array;
    next = options.obj || this._data;
    props = path.split('.');
    path = '';
    i = 0;
    len = props.length;
    while (i < len) {
      parent = next;
      prop = props[i++];
      if (proto && !specHelper.isSpeculative(parent)) {
        parent = specHelper.create(parent);
      }
      pathSegment = prop.dereffedProp || prop;
      prop = prop.arrIndex !== void 0 ? prop.arrIndex : prop;
      path = path ? path + '.' + pathSegment : pathSegment;
      next = parent[prop];
      if (next === void 0) {
        if (!addPath) {
          return {
            obj: next,
            path: path,
            remainingProps: props.slice(i)
          };
        }
        if (array && i === len) {
          next = proto ? specHelper.create([]) : [];
        } else {
          next = proto ? specHelper.create({}) : {};
        }
        parent[prop] = next;
      } else if (proto && typeof next === 'object' && !specHelper.isSpeculative(next)) {
        next = specHelper.create(next);
        parent[prop] = next;
      }
      if (ref = next.$r) {
        if (i === len && options.dontFollowLastRef) {
          return {
            path: path,
            parent: parent,
            prop: prop,
            obj: next
          };
        }
        _ref = this.lookup(ref, addPath, options), rObj = _ref.obj, rPath = _ref.path, rRemainingProps = _ref.remainingProps;
        dereffedPath = rPath + ((rRemainingProps != null ? rRemainingProps.length : void 0) ? '.' + rRemainingProps.join('.') : '');
        if (!(key = next.$k)) {
          next = rObj;
        } else {
          keyVal = this.lookup(key, false, options).obj;
          if (specHelper.isArray(keyVal)) {
            next = keyVal.map(__bind(function(key) {
              return this.lookup(dereffedPath + '.' + key, false, options).obj;
            }, this));
            if (props[i]) {
              props[i] = {
                arrIndex: arrIndex = parseInt(props[i], 10),
                dereffedProp: keyVal[arrIndex]
              };
            }
          } else {
            dereffedPath = dereffedPath + '.' + this.lookup(key, false, options).obj;
            next = this.lookup(dereffedPath, addPath, options).obj;
          }
        }
        if (i < len) {
          path = dereffedPath;
        }
        if (next === void 0 && !addPath && i < len) {
          return {
            obj: next,
            path: path,
            remainingProps: props.slice(i)
          };
        }
      }
    }
    return {
      path: path,
      parent: parent,
      prop: prop,
      obj: next
    };
  }
};
xtraArrMutConf = {
  insertAfter: {
    outOfBounds: function(arr, _arg) {
      var afterIndex, _;
      afterIndex = _arg[0], _ = _arg[1];
      return !((-1 <= afterIndex && afterIndex <= arr.length - 1));
    },
    fn: function(arr, _arg) {
      var afterIndex, value;
      afterIndex = _arg[0], value = _arg[1];
      return arr.splice(afterIndex + 1, 0, value);
    }
  },
  insertBefore: {
    outOfBounds: function(arr, _arg) {
      var beforeIndex, _;
      beforeIndex = _arg[0], _ = _arg[1];
      return !((0 <= beforeIndex && beforeIndex <= arr.length));
    },
    fn: function(arr, _arg) {
      var beforeIndex, value;
      beforeIndex = _arg[0], value = _arg[1];
      return arr.splice(beforeIndex, 0, value);
    }
  },
  remove: {
    outOfBounds: function(arr, _arg) {
      var startIndex, upperBound, _;
      startIndex = _arg[0], _ = _arg[1];
      upperBound = arr.length ? arr.length - 1 : 0;
      return !((0 <= startIndex && startIndex <= upperBound));
    },
    fn: function(arr, _arg) {
      var howMany, startIndex;
      startIndex = _arg[0], howMany = _arg[1];
      return arr.splice(startIndex, howMany);
    }
  }
};
for (method in arrMutators) {
  _ref = arrMutators[method], compound = _ref.compound, normalizeArgs = _ref.normalizeArgs;
  if (compound) {
    continue;
  }
  Memory.prototype[method] = (function(method, normalizeArgs) {
    var fn, outOfBounds, xtraConf;
    if (xtraConf = xtraArrMutConf[method]) {
      outOfBounds = xtraConf.outOfBounds;
      fn = xtraConf.fn;
    }
    return function() {
      var arr, methodArgs, options, out, path, ret, ver, _ref2;
      _ref2 = normalizeArgs.apply(null, arguments), path = _ref2.path, methodArgs = _ref2.methodArgs, ver = _ref2.ver, options = _ref2.options;
      this.ver = ver;
      options.array = true;
      out = this.lookup(path, true, options);
      arr = out.obj;
      if (!specHelper.isArray(arr)) {
        throw new Error('Not an Array');
      }
      if (typeof outOfBounds === "function" ? outOfBounds(arr, methodArgs) : void 0) {
        throw new Error('Out of Bounds');
      }
      ret = fn ? fn(arr, methodArgs) : arr[method].apply(arr, methodArgs);
      if (options.returnMeta) {
        return out;
      } else {
        return ret;
      }
    };
  })(method, normalizeArgs);
}
Memory.prototype.move = function(path, from, to, ver, options) {
  var value;
  if (options == null) {
    options = {};
  }
  value = this.lookup("" + path + "." + from, false, options).obj;
  if (to < 0) {
    to += this.lookup(path, false, options).obj.length;
  }
  if (from > to) {
    this.insertBefore(path, to, value, ver, options);
    from++;
  } else {
    this.insertAfter(path, to, value, ver, options);
  }
  return this.remove(path, from, 1, ver, options);
};