var argsToFKeys, indexInArgs, indexesInArgsForInsert, normArgsInsert, normArgsPop, normArgsPush, splitArgsDefault, splitArgsForInsert;
var __slice = Array.prototype.slice;
module.exports = {
  push: {
    normalizeArgs: normArgsPush = function() {
      var options, path, values, ver, _i;
      path = arguments[0], values = 4 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 2) : (_i = 1, []), ver = arguments[_i++], options = arguments[_i++];
      if (options === void 0) {
        options = {};
      }
      if (options.constructor !== Object) {
        values.push(ver);
        ver = options;
        options = {};
      }
      return {
        path: path,
        methodArgs: values,
        ver: ver,
        options: options
      };
    },
    splitArgs: function(args) {
      return [[], args];
    },
    sliceFrom: 1,
    argsToForeignKeys: argsToFKeys = function(args, path, $r) {
      var newArgs, oldArgs;
      oldArgs = args.slice(this.sliceFrom);
      newArgs = oldArgs.map(function(refObjToAdd) {
        if (refObjToAdd.$r === void 0) {
          throw new Error('Trying to push a non-ref onto an array ref');
        }
        if ($r !== refObjToAdd.$r) {
          throw new Error("Trying to use elements of type " + refToObj.$r + " with path " + path + " that is an array ref of type " + $r);
        }
        return refObjToAdd.$k;
      });
      args.splice.apply(args, [this.sliceFrom, oldArgs.length].concat(__slice.call(newArgs)));
      return args;
    }
  },
  pop: {
    normalizeArgs: normArgsPop = function(path, ver, options) {
      if (options == null) {
        options = {};
      }
      return {
        path: path,
        methodArgs: [],
        ver: ver,
        options: options
      };
    },
    splitArgs: splitArgsDefault = function(args) {
      return [args, []];
    }
  },
  insertAfter: {
    normalizeArgs: normArgsInsert = function(path, pivotIndex, value, ver, options) {
      if (options == null) {
        options = {};
      }
      return {
        path: path,
        methodArgs: [pivotIndex, value],
        ver: ver,
        options: options
      };
    },
    indexesInArgs: indexInArgs = indexesInArgsForInsert = function(args, newVals) {
      if (newVals) {
        args[0] = newVals[0];
        return args;
      }
      return [args[0]];
    },
    splitArgs: splitArgsForInsert = function(args) {
      return [[args[0]], args.slice(1)];
    },
    sliceFrom: 2,
    argsToForeignKeys: argsToFKeys
  },
  insertBefore: {
    normalizeArgs: normArgsInsert,
    indexesInArgs: indexInArgs,
    splitArgs: splitArgsForInsert,
    sliceFrom: 2,
    argsToForeignKeys: argsToFKeys
  },
  remove: {
    normalizeArgs: function(path, startIndex, howMany, ver, options) {
      if (options == null) {
        options = {};
      }
      return {
        path: path,
        methodArgs: [startIndex, howMany],
        ver: ver,
        options: options
      };
    },
    indexesInArgs: indexInArgs,
    splitArgs: splitArgsDefault
  },
  splice: {
    normalizeArgs: function() {
      var newMembers, options, path, removeCount, startIndex, ver, _i;
      path = arguments[0], startIndex = arguments[1], removeCount = arguments[2], newMembers = 6 <= arguments.length ? __slice.call(arguments, 3, _i = arguments.length - 2) : (_i = 3, []), ver = arguments[_i++], options = arguments[_i++];
      if (options === void 0) {
        options = {};
      }
      if (options.constructor !== Object) {
        newMembers.push(ver);
        ver = options;
        options = {};
      }
      return {
        path: path,
        methodArgs: [startIndex, removeCount].concat(__slice.call(newMembers)),
        ver: ver,
        options: options
      };
    },
    indexesInArgs: indexInArgs,
    splitArgs: function(args) {
      return [args.slice(0, 2), args.slice(2)];
    },
    sliceFrom: 3,
    argsToForeignKeys: argsToFKeys
  },
  unshift: {
    normalizeArgs: normArgsPush,
    splitArgs: splitArgsDefault,
    sliceFrom: 1,
    argsToForeignKeys: argsToFKeys
  },
  shift: {
    normalizeArgs: normArgsPop,
    splitArgs: splitArgsDefault
  },
  move: {
    compound: true,
    normalizeArgs: function(path, from, to, ver, options) {
      if (options == null) {
        options = {};
      }
      return {
        path: path,
        methodArgs: [from, to],
        ver: ver,
        options: options
      };
    },
    indexesInArgs: function(args, newVals) {
      var _ref;
      if (newVals) {
        [].splice.apply(args, [0, 2].concat(_ref = newVals.slice(0, 2))), _ref;
        return args;
      }
      return args.slice(0, 2);
    },
    splitArgs: splitArgsDefault
  }
};